"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const error_1 = require("../error");
describe('utils/error', () => {
    describe('GitlyFetchError', () => {
        it('should return an instance', () => {
            const error = new error_1.GitlyFetchError('message');
            expect(error.message).toBe('[gitly:fetch]: message');
            expect(error.code).toBe(-1);
            expect(error.type).toBe(error_1.GitlyErrorType.Fetch);
        });
    });
    describe('GitlyExtractError', () => {
        it('should return an instance', () => {
            const error = new error_1.GitlyExtractError('message');
            expect(error.message).toBe('[gitly:extract]: message');
            expect(error.code).toBe(-1);
            expect(error.type).toBe(error_1.GitlyErrorType.Extract);
        });
    });
    describe('GitlyDownloadError', () => {
        it('should return an instance', () => {
            const error = new error_1.GitlyDownloadError('message', 402);
            expect(error.message).toBe('[gitly:download]: message');
            expect(error.code).toBe(402);
            expect(error.type).toBe(error_1.GitlyErrorType.Download);
        });
    });
    describe('GitlyUknownError', () => {
        it('should return an instance', () => {
            const error = new error_1.GitlyUknownError('message', 402);
            expect(error.message).toBe('[gitly:uknown]: message');
            expect(error.code).toBe(402);
            expect(error.type).toBe(error_1.GitlyErrorType.Unknown);
        });
    });
});
