"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = require("path");
const gitly_1 = __importDefault(require("../gitly"));
const exists_1 = __importDefault(require("../exists"));
const shelljs_1 = require("shelljs");
describe('gitly', () => {
    const destination = (0, path_1.join)(__dirname, 'output', 'gitly');
    const options = {
        temp: (0, path_1.join)(__dirname, 'output', 'gitly'),
    };
    beforeEach(() => {
        (0, shelljs_1.rm)('-rf', (0, path_1.join)(__dirname, 'output', 'gitly'));
    });
    afterEach(() => {
        (0, shelljs_1.rm)('-rf', destination);
    });
    it('should clone the repository using axios', async () => {
        const result = await (0, gitly_1.default)('lukeed/gittar', destination, options);
        expect(await (0, exists_1.default)(result[0])).toBe(true);
        expect(await (0, exists_1.default)(result[1])).toBe(true);
    });
    it('should clone the repository using git', async () => {
        const result = await (0, gitly_1.default)('lukeed/gittar', destination, {
            ...options,
            backend: 'git',
        });
        expect(await (0, exists_1.default)(result[0])).toBe(true);
        expect(await (0, exists_1.default)(result[1])).toBe(true);
    });
});
