"use strict";
var __setFunctionName = (this && this.__setFunctionName) || function (f, name, prefix) {
    if (typeof name === "symbol") name = name.description ? "[".concat(name.description, "]") : "";
    return Object.defineProperty(f, "name", { configurable: true, value: prefix ? "".concat(prefix, " ", name) : name });
};
var _a, _b, _c, _d, _e;
Object.defineProperty(exports, "__esModule", { value: true });
exports.GitlyCloneError = exports.GitlyDownloadError = exports.GitlyExtractError = exports.GitlyFetchError = exports.GitlyUknownError = exports.GitlyErrorType = void 0;
var GitlyErrorType;
(function (GitlyErrorType) {
    GitlyErrorType["Fetch"] = "fetch";
    GitlyErrorType["Clone"] = "clone";
    GitlyErrorType["Extract"] = "extract";
    GitlyErrorType["Download"] = "download";
    GitlyErrorType["Unknown"] = "unknown";
})(GitlyErrorType || (exports.GitlyErrorType = GitlyErrorType = {}));
class GitlyAbstractError extends Error {
    constructor(message, code = -1) {
        super(message);
        this.message = message;
        this.code = code;
        this.rawMessage = message;
        const type = (this.type = this.ctor.type);
        this.message = `[${type ? `gitly:${type}` : 'gitly'}]: ${message}`;
        Object.setPrototypeOf(this, new.target.prototype);
    }
    get ctor() {
        return this.constructor;
    }
}
exports.default = GitlyAbstractError;
exports.GitlyUknownError = (_a = class extends GitlyAbstractError {
    },
    __setFunctionName(_a, "GitlyUknownError"),
    _a.type = GitlyErrorType.Unknown,
    _a);
exports.GitlyFetchError = (_b = class extends GitlyAbstractError {
    },
    __setFunctionName(_b, "GitlyFetchError"),
    _b.type = GitlyErrorType.Fetch,
    _b);
exports.GitlyExtractError = (_c = class extends GitlyAbstractError {
    },
    __setFunctionName(_c, "GitlyExtractError"),
    _c.type = GitlyErrorType.Extract,
    _c);
exports.GitlyDownloadError = (_d = class extends GitlyAbstractError {
    },
    __setFunctionName(_d, "GitlyDownloadError"),
    _d.type = GitlyErrorType.Download,
    _d);
exports.GitlyCloneError = (_e = class extends GitlyAbstractError {
    },
    __setFunctionName(_e, "GitlyCloneError"),
    _e.type = GitlyErrorType.Clone,
    _e);
