"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const axios_1 = __importDefault(require("axios"));
const stream = __importStar(require("stream"));
const util_1 = require("util");
const error_1 = require("./error");
const write_1 = __importDefault(require("./write"));
const pipeline = (0, util_1.promisify)(stream.pipeline);
async function fetch(url, file, options = {}) {
    const response = await axios_1.default.get(url, {
        headers: options.headers,
        responseType: 'stream',
        validateStatus: (status) => status >= 200 && status < 500,
    });
    const { statusText: message, status: code } = response;
    if (code >= 400)
        throw new error_1.GitlyDownloadError(message, code);
    else if (code >= 300 && code < 400 && response.headers.location) {
        return fetch(response.headers.location, file);
    }
    else
        await pipeline(response.data, await (0, write_1.default)(file));
    return file;
}
exports.default = fetch;
